{{
*************************************
* Prop-BIOS BasicI2C_Driver client services
*************************************
}}
CON
   EEPROM   = $A0                      ' I2C EEPROM Device Address

OBJ
  bc: "BIOS_Interface"

PUB Initialize
  bc.run(bc#BIOS_EEPROM_INIT)

PUB Write(data) : ackbit
  bc.set(bc#ARG1,data)
  result := bc.run(bc#BIOS_EEPROM_WRITE)
  
PUB Read(ackbit): data
  bc.set(bc#ARG1,ackbit)
  result := bc.run(bc#BIOS_EEPROM_WRITE)
  
PUB ReadPage(devSel, addrReg, dataPtr, count) : ackbit
  bc.set(bc#ARG1,devSel)
  bc.set(bc#ARG2,addrReg)
  bc.set(bc#ARG3,dataPtr)
  bc.set(bc#ARG4,count)
  result := bc.run(bc#BIOS_EEPROM_READPAGE)
  
PUB ReadByte(devSel, addrReg) : data
  bc.set(bc#ARG1,devSel)
  bc.set(bc#ARG2,addrReg)
  result := bc.run(bc#BIOS_EEPROM_READBYTE)

PUB ReadWord(devSel, addrReg) : data
  bc.set(bc#ARG1,devSel)
  bc.set(bc#ARG2,addrReg)
  result := bc.run(bc#BIOS_EEPROM_READWORD)

PUB ReadLong(devSel, addrReg) : data
  bc.set(bc#ARG1,devSel)
  bc.set(bc#ARG2,addrReg)
  result := bc.run(bc#BIOS_EEPROM_READLONG)

PUB WritePage(devSel, addrReg, dataPtr, count) : ackbit
  bc.set(bc#ARG1,devSel)
  bc.set(bc#ARG2,addrReg)
  bc.set(bc#ARG3,dataPtr)
  bc.set(bc#ARG4,count)
  result := bc.run(bc#BIOS_EEPROM_WRITEPAGE)
  
PUB WriteByte(devSel, addrReg, data)
  bc.set(bc#ARG1,devSel)
  bc.set(bc#ARG2,addrReg)
  bc.set(bc#ARG3,data)
  result := bc.run(bc#BIOS_EEPROM_WRITEBYTE)

PUB WriteWord(devSel, addrReg, data)
  bc.set(bc#ARG1,devSel)
  bc.set(bc#ARG2,addrReg)
  bc.set(bc#ARG3,data)
  result := bc.run(bc#BIOS_EEPROM_WRITEWORD)

PUB WriteLong(devSel, addrReg, data)
  bc.set(bc#ARG1,devSel)
  bc.set(bc#ARG2,addrReg)
  bc.set(bc#ARG3,data)
  result := bc.run(bc#BIOS_EEPROM_WRITELONG)

PUB WriteWait(devSel, addrReg) : ackbit
  bc.set(bc#ARG1,devSel)
  bc.set(bc#ARG2,addrReg)
  result := bc.run(bc#BIOS_EEPROM_WRITEWAIT)