{{
*************************************
* Prop-BIOS Stdio, etc client services
*************************************
}}

OBJ
  bc: "BIOS_Interface"
  sf: "snprintf"

PUB printf(fmt, arg) | pb[256]
{{
Print formatted output using C printf style format. Arg list would be p(v)+p(v2)+p(v3).
Example:
printf(string("I need %d hours in a day and %d hours to %s.\n"), prm(28)+prm(10)+prm(string("sleep")));
Make a local copy of this method and the p(v) method in your code for convenience.
}}
  result := sf.snprintf(@pb,256,fmt,arg)
  print(@pb)

PUB prm(v)
  return sf.p(v)

PUB print(p)
{{
Print string to BIOS_STDOUT
}}
  bc.set(bc#ARG1,p)
  bc.run(bc#BIOS_CONSOLE_PRINT)

PUB error(p)
{{
Print string to BIOS_STDERR
}}
  bc.set(bc#ARG1,p)
  bc.run(bc#BIOS_CONSOLE_ERROR)

PUB getch
{{
Get char from BIOS_STDIN
}}
  bc.run(bc#BIOS_CONSOLE_INPUT)

PUB redirect(stdio, devid)
{{
Redirect device for stdio:
BIOS_STDOUT, BIOS_STDERR, BIOS_STDIN
to devtype:
BIOS_TV, BIOS_VGA, BIOS_FDSERIAL, etc...
}}
  bc.setConsole(stdio, devid)

PUB setColors(p)
{{
Set console palette colors
}}
  bc.set(bc#ARG1,p)
  bc.run(bc#BIOS_CONSOLE_SETCOLORS)

PUB consoleOut(p)
{{
Send a "out" command to console output device
}}
  bc.set(bc#ARG1,p)
  bc.run(bc#BIOS_CONSOLE_OUT)

