{{
*************************************
* CRC16 - Uses CCITT polynomial
*************************************
}}

CON
{
  start with -1 to detect blank array
  mycrc := crc.sum(dptr, bc#BIOS_DBASE_SIZE-2,CRC_INIT)
}
  CRC_INIT = $FFFF
  
DAT
  crc_table
  word $0000, $1189, $2312, $329b,  $4624, $57ad, $6536, $74bf,  $8c48, $9dc1, $af5a, $bed3,  $ca6c, $dbe5, $e97e, $f8f7 '0
  word $1081, $0108, $3393, $221a,  $56a5, $472c, $75b7, $643e,  $9cc9, $8d40, $bfdb, $ae52,  $daed, $cb64, $f9ff, $e876 '1
  word $2102, $308b, $0210, $1399,  $6726, $76af, $4434, $55bd,  $ad4a, $bcc3, $8e58, $9fd1,  $eb6e, $fae7, $c87c, $d9f5 '2
  word $3183, $200a, $1291, $0318,  $77a7, $662e, $54b5, $453c,  $bdcb, $ac42, $9ed9, $8f50,  $fbef, $ea66, $d8fd, $c974 '3
  word $4204, $538d, $6116, $709f,  $0420, $15a9, $2732, $36bb,  $ce4c, $dfc5, $ed5e, $fcd7,  $8868, $99e1, $ab7a, $baf3 '4
  word $5285, $430c, $7197, $601e,  $14a1, $0528, $37b3, $263a,  $decd, $cf44, $fddf, $ec56,  $98e9, $8960, $bbfb, $aa72 '5
  word $6306, $728f, $4014, $519d,  $2522, $34ab, $0630, $17b9,  $ef4e, $fec7, $cc5c, $ddd5,  $a96a, $b8e3, $8a78, $9bf1 '6
  word $7387, $620e, $5095, $411c,  $35a3, $242a, $16b1, $0738,  $ffcf, $ee46, $dcdd, $cd54,  $b9eb, $a862, $9af9, $8b70 '7
  word $8408, $9581, $a71a, $b693,  $c22c, $d3a5, $e13e, $f0b7,  $0840, $19c9, $2b52, $3adb,  $4e64, $5fed, $6d76, $7cff '8
  word $9489, $8500, $b79b, $a612,  $d2ad, $c324, $f1bf, $e036,  $18c1, $0948, $3bd3, $2a5a,  $5ee5, $4f6c, $7df7, $6c7e '9
  word $a50a, $b483, $8618, $9791,  $e32e, $f2a7, $c03c, $d1b5,  $2942, $38cb, $0a50, $1bd9,  $6f66, $7eef, $4c74, $5dfd 'a
  word $b58b, $a402, $9699, $8710,  $f3af, $e226, $d0bd, $c134,  $39c3, $284a, $1ad1, $0b58,  $7fe7, $6e6e, $5cf5, $4d7c 'b
  word $c60c, $d785, $e51e, $f497,  $8028, $91a1, $a33a, $b2b3,  $4a44, $5bcd, $6956, $78df,  $0c60, $1de9, $2f72, $3efb 'c
  word $d68d, $c704, $f59f, $e416,  $90a9, $8120, $b3bb, $a232,  $5ac5, $4b4c, $79d7, $685e,  $1ce1, $0d68, $3ff3, $2e7a 'd
  word $e70e, $f687, $c41c, $d595,  $a12a, $b0a3, $8238, $93b1,  $6b46, $7acf, $4854, $59dd,  $2d62, $3ceb, $0e70, $1ff9 'e
  word $f78f, $e606, $d49d, $c514,  $b1ab, $a022, $92b9, $8330,  $7bc7, $6a4e, $58d5, $495c,  $3de3, $2c6a, $1ef1, $0f78 'f
   
PUB get(msg, len, val) | ii
{{
  Get CRC for len msg with intial ival
  @param msg - byte array message
  @param len - number of bytes in msg array
  @param val - initial crc value ... normally $FFFF
  @returns CCITT CRC16
}}
  repeat ii from 0 to len-1
    val := CRC(val, byte[msg+ii])
  val &= CRC_INIT
  return val

PUB hash(key, mlen, mmask) | len
{{
  Get a CRC16 based hash of key of maximum length mlen key using mmask.
  This function will not create a perfect hash for all data.
  Other algorithms must be used in addition to guarantee uniqueness for keys. 
  @param key - key byte array string 
  @param mlen - maximum number of bytes in msg array
  @param mmask - mask used to defin 2^N hash table size
  @returns CCITT CRC16 based hash
}}
  len := strsize(key)
  if len => mlen  ' just calculate over the first VLEN bytes
    len := mlen
  result := get(key, len, CRC_INIT)
  result &= mmask

PRI CRC(crcval, ch) | ii
  ii := (crcval ^ ch) & $ff
  result := (crcval >> 8) ^ (word[@crc_table + ii<<1]) ' no idea why ii needs to be << 1
   