CON
   '' PinDefs.spin configuration file, adjust or overwrite as needed.

   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000

   'NTSC/PAL Switch
   NTSC = "Y"
   PAL  = "n"
         
   ' Primary Keyboard Single
   KEYBOARD1_DAT = 26
   KEYBOARD1_CLK = 27
   
   ' Primary Mouse Connection Single
   MOUSE1_DAT   = 24
   MOUSE1_CLK   = 25

   ' Primary TV Connection Single
   TV_DAC1      = 20
   
   ' Primary Audio Connection Single
   AUDIO1       = 10
   ' Secondary Audio Connection
   AUDIO2       = 11

   VGA1         = 16
   
   ' Primary SD media Connections
   FSRW1_DO     = 12
   FSRW1_Clk    = 13
   FSRW1_DI     = 14
   FSRW1_CS     = 15

   'DS1302 Clock Settings
   DS1302_INCLK  = 0
   DS1302_INIO   = 0
   DS1302_CS     = 0

   ' Serial I/O
   SERIAL1_TX    = 30
   SERIAL1_RX    = 31
   SERIAL1_MODE  = 0
   SERIAL1_BAUD  = 115200

   ' Primary EEPROM
   EEPROM1_SCL = 28
   EEPROM1_DAT = 29
   
   ' XBee Configuration
   XBEE1_TX      = 0
   XBEE1_RX      = 0

   ' HYDRA NET Configuration
   HYDRANET_TX   = 0
   HYDRANET_RX   = 0
   
   ' NES bit encodings general for state bits
   NES_RIGHT     = %00000001
   NES_LEFT      = %00000010
   NES_DOWN      = %00000100
   NES_UP        = %00001000
   NES_START     = %00010000
   NES_SELECT    = %00100000
   NES_B         = %01000000
   NES_A         = %10000000
   
   ' NES bit encodings for NES gamepad 0 
   NES0_RIGHT    = %00000000_00000001
   NES0_LEFT     = %00000000_00000010
   NES0_DOWN     = %00000000_00000100
   NES0_UP       = %00000000_00001000
   NES0_START    = %00000000_00010000
   NES0_SELECT   = %00000000_00100000
   NES0_B        = %00000000_01000000
   NES0_A        = %00000000_10000000

   ' NES bit encodings for NES gamepad 1
   NES1_RIGHT    = %00000001_00000000
   NES1_LEFT     = %00000010_00000000
   NES1_DOWN     = %00000100_00000000
   NES1_UP       = %00001000_00000000
   NES1_START    = %00010000_00000000
   NES1_SELECT   = %00100000_00000000
   NES1_B        = %01000000_00000000
   NES1_A        = %10000000_00000000

   ' Nes Controller I/O Configuration
   JOY_CLK       = 3
   JOY_SHLDn     = 4
   JOY_DATAOUT0  = 5
   JOY_DATAOUT1  = 6

   ' PropGFX Lite I/O Configuration
   PG_RXSPEED   = 256_000
   PG_RXPIN     = 24
   PG_TXPIN     = 25
   MYCLKVAL     = %00000010_00000000_00000000_00000000
   MYDIRAVAL    = %00000010_00000000_00000000_11111111
   MYPINOKVAL   = %00000001_00000000_00000000_00000000
   MYDATASHIFT  = 0   

   'Debug LED Configuration
   'LED1         = 0
   'LED2         = 1
   'LED3         = 3
   
   ' ENC28J60 Ethernet settings - Remarked to save memory if not required.
   ENC1_CS       = "n"
   ENC1_SCK      = "n"
   ENC1_SI       = "n"
   ENC1_SO       = "n" 
   ENC1_INT      = "n"

   {
DAT
   mac_addr      byte    $10, $00, $00, $00, $00, $01

   ip_addr       byte    192, 168, 1, 200                  ' device's ip address
   ip_subnet     byte    255, 255, 255, 0                  ' network subnet
   ip_gateway    byte    192, 168, 1, 1                    ' network gateway (router)
   ip_dns        byte    192, 168, 1, 1                    ' network dns   
}
PUB Start
   